#include "KarPNGLoader.as";

int clap = 1;
void onInit(CBlob@ this)
{
	this.set_f32("gib health", -3.0f);
	this.Tag("player");
	this.set_u8("NextPoint", 0);
	this.set_u8("CurrentLap", clap);
	this.set_bool("Finished", false);

	CSprite@ sprite = this.getSprite();

	if (sprite !is null)
	{
		sprite.SetZ(100.0f); 
	}

	this.getShape().SetRotationsAllowed(true);
	this.getShape().getConsts().net_threshold_multiplier = 0.5f;
}

void onTick(CBlob@ this)
{
	u8 np = this.get_u8("NextPoint");
	u8 CPCount = getRules().get_u8("CPCount");
	u8 TLaps = getRules().get_u8("TotalLaps");	

	if ( np == CPCount && getMap().getTile(this.getPosition()).type == CMap::checkers )
	{
		if (clap >= TLaps)
		{
			this.set_bool("Finished", true);
		}
		else
		{
			clap++;
			this.set_u8("CurrentLap", clap);
			this.set_u8("NextPoint", 0);
		}
	}

	CBlob@[] blobsInRadius;
	if (this.getMap().getBlobsInRadius(this.getPosition(), this.getRadius(), @blobsInRadius))
	{
		for (uint i = 0; i < blobsInRadius.length; i++)
		{
			CBlob @b = blobsInRadius[i];
			if(b !is null && b.getName() == "checkpoint")
			{
				u8 np = this.get_u8("NextPoint")+1;

				if (b.get_u8("Number") == np)
				{
					//print("np"+ np);
					//print("number"+ b.get_u8("Number"));
					this.set_u8("NextPoint", np);
				}
			}
		}
	}
}

void onSetPlayer(CBlob@ this, CPlayer@ player)
{
	if (player !is null)
	{
		player.SetScoreboardVars("ScoreboardIcons.png", 2, Vec2f(16, 16));
	}
}

void onRender(CSprite@ this)
{
	CBlob@ blob = this.getBlob();
	u8 np = blob.get_u8("NextPoint");
	u8 CPCount = getRules().get_u8("CPCount");
	u8 TLaps = getRules().get_u8("TotalLaps");
	u8 currentLap = blob.get_u8("CurrentLap");
	f32 rpm = blob.get_f32("RPM");

	GUI::SetFont("hud");
	GUI::DrawText("CheckPoint "+ np + " / " + CPCount, Vec2f(getScreenWidth()-512, getScreenHeight()-32), color_white);
	GUI::DrawText("Laps "+ currentLap + " / " + TLaps, Vec2f(getScreenWidth()-512, getScreenHeight()-16), color_white);
	GUI::DrawText("RPM = "+ rpm, Vec2f(getScreenWidth()-512, 196), color_white);
}