namespace GearState
{
	enum Gear
	{
		neutral = 0,
		gear1,
		gear2,
		gear3,
		gear4,
		gear5,
		gear6,
	}
}

namespace CarMovementVars
{
	// const ::s32 resheath_time = 2; 
	// const ::s32 slash_charge = 15;
	// const ::s32 slash_charge_level2 = 38;
	// const ::s32 slash_charge_limit = slash_charge_level2 + slash_charge + 10;
	// const ::s32 slash_move_time = 4;
	// const ::s32 slash_time = 13;
	// const ::s32 double_slash_time = 8;

	const ::f32 max_speed = 100.0f;
}

shared class CarMoveVars
{
	f32 rpmAmount;
	f32 speedAmount;
	u8 maxSpeed;
	u8 state;

	u16 currentGear;
	u16 GearMaxRPM;
	u16 GearMinRPM;

	f32 turnSpeed;
	f32 turnFactor;

	f32 maxVel;
	f32 thrustFactor;

	s32 accelAmount;
	f32 overallScale;

	f32 stoppingForce;
	f32 stoppingForceAir;
	f32 stoppingFactor;
};

void onInit(CMovement@ this)
{
	this.getCurrentScript().removeIfTag = "dead";
	this.getCurrentScript().runFlags |= Script::tick_not_attached;

	CarMoveVars moveVars;

	moveVars.turnSpeed = 2.6f;
	moveVars.maxVel = 60.0f;
	moveVars.thrustFactor = 1.0f;

	moveVars.currentGear = 0;
	//moveVars.GearMaxRPM = 200;

	moveVars.rpmAmount = 0.0f;
	moveVars.speedAmount = 0.0f;
	moveVars.maxSpeed = 120;

	moveVars.accelAmount = 0.0f;
	moveVars.overallScale = 1.0f;

	moveVars.stoppingForce = 1.10f;
	moveVars.stoppingForceAir = 2.00f;
	moveVars.stoppingFactor = 1.0;

	this.getBlob().set("moveVars", moveVars);
}
