#include "KartsCommon.as"

bool myPlayerGotToTheEnd = false;
int finishedCount = 0;
string endGameText = "You Finished";
const float END_DIST = 49.0f;

void Reset(CRules@ this)
{
	myPlayerGotToTheEnd = false;
	finishedCount = 0;
}

void onRestart(CRules@ this)
{
	Reset(this);
}

void onInit(CRules@ this)
{
	Reset(this);
}

void onInit(CMap@ this)
{
	CRules@ rules = getRules();
	SetIntroduction(rules, "Race");

	if (getNet().isServer())
	{
		rules.set_bool("repeat if dead", true);
		
		// make stats file
		Stats_MakeFile(rules, "Race");
		ConfigFile stats;
		if (!stats.loadFile("../Cache/" + g_statsFile))
		{
			Stats_Add_IndividualTimeMeasures(stats);
			Stats_Add_TeamTimeMeasures(stats);

			stats.saveFile(g_statsFile);
		}
	}

	AddRulesScript(rules);

}

void onTick(CMap@ this)
{
	CRules@ rules = getRules();

	// local player check end

	CBlob@ localBlob = getLocalPlayerBlob();
	if (localBlob !is null)
	{
		if (!myPlayerGotToTheEnd && localBlob.get_bool("Finished"))
		{
			myPlayerGotToTheEnd = true;
			Sound::Play("/Whistle");
		}
	}
	// server check

	if (getNet().isServer())
	{
		if (rules.isGameOver())
		{
			// sync stats

			if (!syncedStats)
			{
				ConfigFile stats;
				string output;
				if (stats.loadFile("../Cache/" + g_statsFile))
				{
					output += Stats_Begin_Output();
					output += Stats_Output_IndividualTimeMeasures(stats);
					output += Stats_Output_TeamTimeMeasures(stats);

					Stats_Send(rules, output);
				}
				syncedStats = true;
			}

			return;
		}		
	}
	// server check

	CBlob@[] players;
	getBlobsByTag("player", @players);
	int playersCount = 0;
	for (uint i = 0; i < players.length; i++)
	{
		CBlob @b = players[i];
		if (b.getPlayer() !is null && !b.hasTag("checkpoint") && b.get_bool("Finished"))
		{
			b.Tag("checkpoint");
			finishedCount++;

			CRules@ rules = getRules();

			// stat time
			ConfigFile stats;
			if (stats.loadFile("../Cache/" + g_statsFile))
			{
				const string playerName = b.getPlayer().getUsername();
				const u32 currentTime = Stats_getCurrentTime(rules);

				Stats_Mark_TeamName(stats, playerName);

				
				for (uint i = 0; i < players.length; i++)
				{
					if (players[i].getTeamNum() == 0)
						playersCount++;
				}

				printf("finishedCount " + finishedCount + " players " + playersCount);
				if (finishedCount == playersCount) // all players
				{
					//rules.set_bool("played fanfare", true); //
					DefaultWin(rules);
					rules.SetGlobalMessage(endGameText);

					// stat time
					if (finishedCount > 1)
					{
						Stats_Mark_TeamTimes(stats, currentTime);
					}
				}

				Stats_Mark_IndividualTime(stats, playerName, currentTime);

				stats.saveFile(g_statsFile);
			}
		}
	}
	
}

// render

void onRender(CRules@ this)
{	
	Stats_Draw(this);
}
