Random map_random(3253251239);

#include "LoadMapUtils.as";
u8 CheckpointCount = 0;
namespace CMap
{	// tiles	
	const SColor color_water(255, 2, 100, 125);
	const SColor color_waypoint(255, 1, 1, 1);
	const SColor color_intermission_place(255, 0, 200, 255);

	const SColor color_sand2(255, 236, 213, 148);
	const SColor color_grass2(255, 100, 155, 16);
	const SColor color_road(255, 19, 13, 29);
	const SColor color_candycanered(255, 210, 0, 0);
	const SColor color_checkers(255, 240, 240, 240);
	const SColor color_stonewall(255, 70, 70, 70);
	const SColor color_dirtwall(255, 85, 42, 17);
	//blobs
	const SColor color_palmtree(255, 0, 150, 0);
	const SColor color_bigtree1(255, 0, 151, 0);
	const SColor color_bigtree2(255, 0, 152, 0);
	const SColor color_bigtree3(255, 0, 153, 0);
	const SColor color_haybale(255, 235, 176, 101);


	const SColor color_corner16(255, 240, 240, 230);	
	const SColor color_corner24(255, 240, 240, 220);
	const SColor color_corner32(255, 240, 240, 210);
	const SColor color_corner40(255, 240, 240, 200);
	const SColor color_corner48(255, 240, 240, 190);

	const SColor color_corner48out(255, 240, 230, 190);
	const SColor color_corner48out90(255, 240, 231, 190);

	const SColor color_straight(255, 255, 128, 0);
	const SColor color_straight45(255, 255, 128, 45);
	const SColor color_straight90(255, 255, 128, 90);	
	const SColor color_straight135(255, 255, 128, 135);

	const SColor color_checkpoint(255, 230, 230, 230);

	//spawn
	const SColor color_blue_main_spawn(0xFF00FFFF); // ARGB(255,   0, 255, 255);

	void SetupMap( CMap@ map, int width, int height )
	{
		map.CreateTileMap( width, height, 8.0f, "world.png" );
		map.CreateSky( SColor(255, 2, 100, 125) );
		map.topBorder = map.bottomBorder = map.rightBorder = map.leftBorder = true;
	} 

	enum Tiles
	{		
		water = 0,		
		sand2 = 385,
		grass2 = 390,
		road = 400,
		candycanered = 401,
		checkers = 402,

		stonewalltl = 416,
		stonewalltm = 417,
		stonewalltr = 418,
		stonewallbl = 432,
		stonewallbm = 433,
		stonewallbr = 434,

		dirtwall = 16,
	
		dirtwalltl = 448,
		dirtwalltm = 449,
		dirtwalltr = 450,
		dirtwallml = 464,
		dirtwallm = 465,
		dirtwallmr = 466,
		dirtwallbl = 480,
		dirtwallbm = 481,
		dirtwallbr = 482,
		
	};

	SColor pixel_R = color_water;
	SColor pixel_RU = color_water;
	SColor pixel_U = color_water;
	SColor pixel_LU = color_water;
	SColor pixel_L = color_water;
	SColor pixel_LD = color_water;
	SColor pixel_D = color_water;
	SColor pixel_RD = color_water;

	void handlePixel( CMap@ map, CFileImage@ image, SColor pixel, int offset, Vec2f pixelPos)
	{	
		u8 alpha = pixel.getAlpha();

		if ( image !is null && image.isLoaded() )
		{
			image.setPixelPosition( pixelPos + Vec2f(1, 0) );
			if (image.canRead())
				pixel_R = image.readPixel();
			
			image.setPixelPosition( pixelPos + Vec2f(1, -1) );
			if (image.canRead())
				pixel_RU = image.readPixel();
			
			image.setPixelPosition( pixelPos + Vec2f(0, -1) );
			if (image.canRead())
				pixel_U = image.readPixel();
			
			image.setPixelPosition( pixelPos + Vec2f(-1, -1) );
			if (image.canRead())
				pixel_LU = image.readPixel();
			
			image.setPixelPosition( pixelPos + Vec2f(-1, 0) );
			if (image.canRead())
				pixel_L = image.readPixel();
			
			image.setPixelPosition( pixelPos + Vec2f(-1, 1) );
			if (image.canRead())
				pixel_LD = image.readPixel();
			
			image.setPixelPosition( pixelPos + Vec2f(0, 1) );
			if (image.canRead())
				pixel_D = image.readPixel();
			
			image.setPixelPosition( pixelPos + Vec2f(1, 1) );
			if (image.canRead())
				pixel_RD = image.readPixel();
				
			image.setPixelOffset(offset);
		}

		if(alpha < 255)
		{
			alpha &= ~0x80;
			SColor rgb = SColor(0xFF, pixel.getRed(), pixel.getGreen(), pixel.getBlue());
			const Vec2f position = getSpawnPosition(map, offset);

			 if(rgb == color_checkpoint)
			{
				CBlob@ blob = spawnBlob( map, "checkpoint", offset, -1, true);

				if (blob !is null)
				{
					blob.set_u8("Number", alpha-100);
				}

				map.SetTile(offset, CMap::road );
				map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
			}
		}



		//tiles
		else if (pixel == color_sand2) 
		{
			map.SetTile(offset, CMap::sand2 + map_random.NextRanged(4) );
			map.AddTileFlag( offset, Tile::BACKGROUND );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES );
		}
		else if (pixel == color_waypoint) 
		{			
			AddMarker( map, offset, "waypoint" );
			map.SetTile(offset, CMap::road);
			map.AddTileFlag( offset, Tile::BACKGROUND );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES );
		}
		else if (pixel == color_intermission_place) 
		{			
			AddMarker( map, offset, "intermission_cam" );
			map.SetTile(offset, CMap::road);
			map.AddTileFlag( offset, Tile::BACKGROUND );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES );
		}
		else if (pixel == color_grass2) 
		{			
			map.SetTile(offset, CMap::grass2 + map_random.NextRanged(5));
			map.AddTileFlag( offset, Tile::BACKGROUND );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES );
		}
		else if (pixel == color_road) 
		{
			if (pixel_L == color_road && pixel_U == color_road && pixel_R == color_grass2 && pixel_D == color_grass2)
			{
				map.SetTile(offset, CMap::grass2 + 34 );
			}
			else if (pixel_R == color_road && pixel_U == color_road && pixel_L == color_grass2 && pixel_D == color_grass2)
			{
				map.SetTile(offset, CMap::grass2 + 35 );
			}
			else if (pixel_L == color_road && pixel_D == color_road && pixel_R == color_grass2 && pixel_U == color_grass2)
			{
				map.SetTile(offset, CMap::grass2 + 36 );
			}
			else if (pixel_R == color_road && pixel_D == color_road && pixel_L == color_grass2 && pixel_U == color_grass2)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::road );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_candycanered) 
		{
			if (pixel_L == color_road && pixel_U == color_road && pixel_R == color_candycanered && pixel_D == color_candycanered)
			{
				map.SetTile(offset, CMap::candycanered + 7 );
			}
			else if (pixel_R == color_road && pixel_U == color_road && pixel_L == color_candycanered && pixel_D == color_candycanered)
			{
				map.SetTile(offset, CMap::candycanered + 8 );
			}
			else if (pixel_L == color_road && pixel_D == color_road && pixel_R == color_candycanered && pixel_U == color_candycanered)
			{
				map.SetTile(offset, CMap::candycanered + 9 );
			}
			else if (pixel_R == color_road && pixel_D == color_road && pixel_L == color_candycanered && pixel_U == color_candycanered)
			{
				map.SetTile(offset, CMap::candycanered + 10 );
			}
			else
			{	
				map.SetTile(offset, CMap::candycanered );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_stonewall) 
		{
			if (pixel_L != color_stonewall && pixel_R == color_stonewall && pixel_U == color_stonewall)
			{
				map.SetTile(offset, CMap::stonewallbl );
			}

			else if (pixel_L != color_stonewall && pixel_R == color_stonewall && pixel_D == color_stonewall)
			{
				map.SetTile(offset, CMap::stonewalltl );
			}
			else if (pixel_L == color_stonewall && pixel_R == color_stonewall && pixel_U == color_stonewall)
			{
				map.SetTile(offset, CMap::stonewallbm );
			}
			else if (pixel_L == color_stonewall && pixel_R == color_stonewall && pixel_D == color_stonewall)
			{
				map.SetTile(offset, CMap::stonewalltm );
			}
			else if (pixel_R != color_stonewall && pixel_L == color_stonewall && pixel_U == color_stonewall)
			{
				map.SetTile(offset, CMap::stonewallbr );
			}

			else if (pixel_R != color_stonewall && pixel_L == color_stonewall && pixel_D == color_stonewall)
			{
				map.SetTile(offset, CMap::stonewalltr );
			}

			map.AddTileFlag( offset, Tile::SOLID | Tile::COLLISION | Tile::LIGHT_PASSES );
		}
		else if (pixel == color_dirtwall) 
		{
			/*if (pixel_L != color_dirtwall && pixel_U != color_dirtwall && pixel_R == color_dirtwall && pixel_D == color_dirtwall)
			{
				CBlob@ blob = spawnBlob( map, "dirtcorner", offset, -1, false);	
				blob.getShape().SetOffset(Vec2f(-1, 1));
				blob.setAngleDegrees(270.0f);
				blob.getShape().SetStatic(true);
			}
			else if (pixel_L == color_dirtwall && pixel_D == color_dirtwall && pixel_R != color_dirtwall && pixel_U != color_dirtwall)
			{
				CBlob@ blob = spawnBlob( map, "dirtcorner", offset, -1, false);	
				blob.getShape().SetOffset(Vec2f(-1, 1));
				blob.getShape().SetStatic(true);				
			}
			else if (pixel_L != color_dirtwall && pixel_D != color_dirtwall && pixel_R == color_dirtwall && pixel_U == color_dirtwall)
			{
				CBlob@ blob = spawnBlob( map, "dirtcorner", offset, -1, false);	
				blob.getShape().SetOffset(Vec2f(-1, 1));
				blob.setAngleDegrees(180.0f);
				blob.getShape().SetStatic(true);
			}
			else if (pixel_L == color_dirtwall && pixel_D != color_dirtwall && pixel_R != color_dirtwall && pixel_U == color_dirtwall)
			{
				CBlob@ blob = spawnBlob( map, "dirtcorner", offset, -1, false);
				blob.getShape().SetOffset(Vec2f(-1, 1));
				blob.setAngleDegrees(90.0f);
				blob.getShape().SetStatic(true);
			}
			else */
			
				map.SetTile(offset, CMap::dirtwall);
				map.AddTileFlag( offset, Tile::SOLID | Tile::COLLISION);
			
		}
		else if (pixel == color_checkers) 
		{
			map.SetTile(offset, CMap::checkers );
			map.AddTileFlag( offset, Tile::BACKGROUND );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES );
		}

		//blobs
		else if (pixel == color_palmtree) 
		{			
			CBlob@ palmtreeBlob = spawnBlob( map, "palmtree", offset, -1, true);	
			if (palmtreeBlob !is null) // add research to first hall
			{
				palmtreeBlob.SetFacingLeft(XORRandom(2) == 0);
			}
			map.SetTile(offset, CMap::grass2 );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_bigtree1) 
		{			
			CBlob@ blob = spawnBlob( map, "bigtree1", offset, -1, true);	
			if (blob !is null) // add research to first hall
			{
				blob.SetFacingLeft(XORRandom(2) == 0);
				blob.getSprite().SetRelativeZ(500.0f);
			}
			map.SetTile(offset, CMap::grass2 );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_bigtree2) 
		{			
			CBlob@ blob = spawnBlob( map, "bigtree2", offset, -1, true);	
			if (blob !is null) // add research to first hall
			{
				blob.SetFacingLeft(XORRandom(2) == 0);
				blob.getSprite().SetRelativeZ(500.0f);
			}
			map.SetTile(offset, CMap::grass2 );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_bigtree3) 
		{			
			CBlob@ blob = spawnBlob( map, "bigtree3", offset, -1, true);	
			if (blob !is null) // add research to first hall
			{
				blob.SetFacingLeft(XORRandom(2) == 0);
				blob.getSprite().SetRelativeZ(500.0f);
			}
			map.SetTile(offset, CMap::grass2 );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_haybale) 
		{			
			CBlob@ blob = spawnBlob( map, "haybale", offset, -1, false);	
			
			map.SetTile(offset, CMap::grass2 );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_corner16) 
		{			
			CBlob@ corner16 = spawnBlob( map, "corner16", offset, 1, true);	
				
			if (pixel_R == color_road && pixel_D == color_road)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::grass2 );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_corner24) 
		{			
			CBlob@ corner24 = spawnBlob( map, "corner24", offset, 1, true);	
					
			if (pixel_R == color_road && pixel_D == color_road)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::grass2 );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_corner32) 
		{			
			CBlob@ corner32 = spawnBlob( map, "corner32", offset, 1, true);	
						
			if (pixel_R == color_road && pixel_D == color_road)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::grass2 );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_corner40) 
		{			
			CBlob@ corner40 = spawnBlob( map, "corner40", offset, 1, true);	
						
			if (pixel_R == color_road && pixel_D == color_road)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::grass2 );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_corner48) 
		{			
			CBlob@ corner48 = spawnBlob( map, "corner48", offset, 1, true);	
						
			if (pixel_R == color_road && pixel_D == color_road)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::grass2 );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_corner48out) 
		{			
			CBlob@ corner48out = spawnBlob( map, "corner48out", offset, 1, true);	
						
			if (pixel_R == color_road && pixel_D == color_road)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::grass2 );
			}
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}		
		else if (pixel == color_corner48out90) 
		{			
			CBlob@ corner48out90 = spawnBlob( map, "corner48out", offset, 1, false);	
			corner48out90.setAngleDegrees(-90.0f);
			corner48out90.getSprite().SetOffset(Vec2f(0, 0));
			corner48out90.SetFacingLeft(true);
						
			if (pixel_R == color_road && pixel_D == color_road)
			{
				map.SetTile(offset, CMap::grass2 + 37 );
			}
			else
			{	
				map.SetTile(offset, CMap::grass2 );
			}
			corner48out90.getShape().SetStatic(true);
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}

		else if (pixel == color_straight) 
		{			
			CBlob@ corner48 = spawnBlob( map, "straight", offset, 1, true);	
			map.SetTile(offset, CMap::road );			
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
		else if (pixel == color_straight45) 
		{			
			CBlob@ straight45 = spawnBlob( map, "straight", offset, 1, false);	
			if (straight45 !is null)
			{
				straight45.setAngleDegrees(45.0f);

				if (pixel_R == color_road && pixel_D == color_road)
				{
					straight45.getSprite().SetOffset(Vec2f(-1, -3));					
					map.SetTile(offset, CMap::grass2 + 37 );
				}
				else
				{
					straight45.getSprite().SetOffset(Vec2f(1, 3));
					map.SetTile(offset, CMap::grass2 + 35 );
				}

				straight45.getShape().SetStatic(true);
				map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
			}
		}
		else if (pixel == color_straight90) 
		{			
			CBlob@ straight90 = spawnBlob( map, "straight", offset, 1, false);	
			if (straight90 !is null)
			{
				straight90.setAngleDegrees(90.0f);
				map.SetTile(offset, CMap::road );			
				map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
				straight90.getShape().SetStatic(true);
			}
		}
		else if (pixel == color_straight135) 
		{			
			CBlob@ straight135 = spawnBlob( map, "straight", offset, 1, false);	
			if (straight135 !is null)
			{
				straight135.setAngleDegrees(135.0f);
				straight135.getShape().SetStatic(true);
				map.SetTile(offset, CMap::grass2+35 );			
				map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
				
			}
		}
		else if(pixel == color_blue_main_spawn)
		{
			CBlob@ blob = spawnBlob( map, "slot", offset, 1, false);	
			if (blob !is null)
			{
				//blob.setAngleDegrees(135.0f);
				blob.getShape().SetStatic(true);				
			}
			//AddMarker(map, offset, "blue main spawn");
			map.SetTile(offset, CMap::road );
			map.AddTileFlag( offset, Tile::LIGHT_PASSES | Tile::BACKGROUND );
		}
	}
}